import torch
import torch.nn as nn
import torch.nn.functional as F


class MovingAttentionModule(nn.Module):
    def __init__(self):
        super().__init__()
        # self.movan_conv6 = nn.Sequential(
        #     nn.Conv2d(1, 1, kernel_size=1, stride=1, padding=0, bias=True),
        #     nn.BatchNorm2d(1),
        #     nn.ReLU(inplace=True))
        #
        # self._init_weights()

    # def _init_weights(self):
    #     nn.init.normal_(self.movan_conv6[0].weight, std=0.01)
    #     nn.init.normal_(self.movan_conv6[0].bias, std=0.01)

    def detectron_weight_mapping(self):
        return dict(), []

    def forward(self, x, backbone_feat_wh):
        diff = torch.abs(self.gray_transformer(x[:, 3:, :, :]) - self.gray_transformer(x[:, :3, :, :]))
        # diff = diff / 255.0
        # attention_map = self.movan_conv6(diff)
        attention_map = F.adaptive_avg_pool2d(diff, backbone_feat_wh)
        assert(attention_map.shape[:2] == (1, 1))

        return attention_map

    @staticmethod
    def gray_transformer(tensor):
        x = (0.21 * tensor[:, 0, :, :] + 0.72 * tensor[:, 1, :, :] + 0.07 * tensor[:, 2, :, :])
        x = x.unsqueeze(1)
        return x
